#include <vtoo/term.h>
#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>

void at_init(void);
void at_exit(void);

int main(int argc, char **argv) {
   at_init();   
   set_style(BOLD);
   printf("Attributes allow text to be styled in different ways:\n\n");
   set_style(NO_ATTRIBS);
   printf("No Attributes!\n");
   set_style(BOLD);
   printf("Bold Text!\n");
   set_style(EMPHASIS);
   printf("Emphasis Text!\n");
   set_style(BLINKING);
   printf("Blinking Text!\n");
   set_style(BOLD | BLINKING);
   printf("Bold and Blinking Text!\n");
   set_style(EMPHASIS | BLINKING);
   printf("Emphasis and Blinking Text!\n");
   set_style(LOW_INTENSITY);
   printf("Low Intensity Text!\n");
   set_style(INVERSE);
   printf("Inverse Text!\n");
   set_style(BOLD | EMPHASIS);
   printf("Bold and Emphasis Text!\n");
   set_style(BOLD | EMPHASIS | BLINKING);
   printf("Bold and Emphasis and Blinking Text!\n");
   flush();
   getchar();
   set_style(NO_ATTRIBS); //to stop clear() from producing a background where attribs affect background color

   clear();
   set_style(BOLD);

   locate(0,0);
   printf("Attributes also allow you to play with colors, both in foreground and in background!:\n\n");
   set_style(WHITE | BLACK_BG);
   locate(2,0);
   printf(" COLOR! ");
   set_style(CYAN | BLACK_BG);
   locate(3,0);
   printf(" COLOR! ");
   set_style(MAGENTA | BLACK_BG);
   locate(4,0);
   printf(" COLOR! ");
   set_style(YELLOW | BLACK_BG);
   locate(5,0);
   printf(" COLOR! ");
   set_style(RED | BLACK_BG);
   locate(6,0);
   printf(" COLOR! ");
   set_style(GREEN | BLACK_BG);
   locate(7,0);
   printf(" COLOR! ");
   set_style(BLUE | BLACK_BG);
   locate(8,0);
   printf(" COLOR! ");

   set_style(WHITE | BLACK_BG);
   locate(2,8);
   printf(" COLOR! ");
   set_style(WHITE | GREEN_BG);
   locate(3,8);
   printf(" COLOR! ");
   set_style(WHITE | BLUE_BG);
   locate(4,8);
   printf(" COLOR! ");
   set_style(WHITE | RED_BG);
   locate(5,8);
   printf(" COLOR! ");
   set_style(WHITE | CYAN_BG);
   locate(6,8);
   printf(" COLOR! ");
   set_style(WHITE | MAGENTA_BG);
   locate(7,8);
   printf(" COLOR! ");
   set_style(WHITE | YELLOW_BG);
   locate(8,8);
   printf(" COLOR! ");
   flush();
   getchar();
   set_style(NO_ATTRIBS); //to stop clear() from producing a yellow background
   clear();
   set_style(BOLD);
   locate(0,0);
   printf("Colors and attributes can be mixed easily:\n\n");
   set_style(BOLD | EMPHASIS | BLINKING | YELLOW | BLUE_BG);
   printf("EXAMPLE!");
   flush();
   getchar();
   clear();
   set_style(BOLD);
   locate(0,0);
   printf("Setting a color as background before calling clear() will change the background on supported terminals.\n\nThat is all for this demo. Press a key to exit"); 
   flush();
   getchar();
   return 0;
}


void at_init(void) {
   atexit(at_exit);
   clear();
   term_buffer_full();
   echo_off();
   locate(0,0);
   toggle_cursor();
   flush();
}

void at_exit(void) {
   toggle_cursor();
   term_buffer_line();
   set_style(NO_ATTRIBS);
   clear();
   echo_on();
   locate(0,0);
   flush();
}
