#include <vtoo/term.h>
#include <vtoo/input.h>
#include <vtoo/text.h>
#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

void at_init(void);
void at_exit(void);
void draw(void);

alignment align;

int main(int argc, char **argv) {

   at_init();
   align = ALIGN_LEFT;
   atwinch(draw); 
   char r = '\0';
   while (r != 'q') {
      draw();
      r = get_input_charset("qlrc");
      switch(r) {
         case 'r': align = ALIGN_RIGHT;  break;
         case 'l': align = ALIGN_LEFT;   break;
         case 'c': align = ALIGN_MIDDLE; break;
      }
   }
   return 0;
}

void draw(void) {
   clear();
   char* text = "vtoo includes a text wrapping function that can make life significantly "
                "easier when developing complex interfaces on the console. You can change "
                "the way this text is aligned by pressing 'l', 'r', and 'c'. Press 'q' to exit "
                "this demonstration. If the size of this terminal changes, this demonstration "
                "will re-wrap the text to match.";
   set_style(BOLD);
   print_text_wrapped(0,0,cols(),rows(),text,align);
   set_style(NO_ATTRIBS);
   flush();
}

void at_init(void) {
   atexit(at_exit);
   clear();
   term_buffer_full();
   echo_off();
   locate(0,0);
   toggle_cursor();
   flush();
}

void at_exit(void) {
   toggle_cursor();
   term_buffer_line();
   set_style(NO_ATTRIBS);
   clear();
   echo_on();
   locate(0,0);
   flush();
}
